import * as React from 'react';
import { StyletronComponent } from 'styletron-react';
import { Override } from '../overrides';

export declare const SIZE: {
  small: 'small';
  medium: 'medium';
  large: 'large';
};
export interface ProgressBarOverrides {
  Root?: Override<any>;
  BarContainer?: Override<any>;
  Bar?: Override<any>;
  BarProgress?: Override<any>;
  InfiniteBar?: Override<any>;
  Label?: Override<any>;
}
export interface ProgressBarProps {
  ariaLabel?: string;
  'aria-label'?: string;
  children?: React.ReactNode;
  getProgressLabel?: (value: number, successValue: number) => React.ReactNode;
  infinite?: boolean;
  overrides?: ProgressBarOverrides;
  size?: typeof SIZE[keyof typeof SIZE];
  showLabel?: boolean;
  steps?: number;
  successValue?: number;
  minValue?: number;
  maxValue?: number;
  value?: number;
}
export class ProgressBar extends React.Component<ProgressBarProps> {}

export interface ProgressBarRoundedOverrides {
  Root?: Override<any>;
  Svg?: Override<any>;
  TrackBackground?: Override<any>;
  TrackForeground?: Override<any>;
  Text?: Override<any>;
}

export interface ProgressBarRoundedProps {
  progress?: number;
  size?: typeof SIZE[keyof typeof SIZE];
  animate?: boolean;
  inline?: boolean;
  overrides?: ProgressBarRoundedOverrides;
}
export declare const ProgressBarRounded: React.FC<ProgressBarRoundedProps>;

export declare const StyledRoot: StyletronComponent<any, any>;
export declare const StyledBarContainer: StyletronComponent<any, any>;
export declare const StyledBar: StyletronComponent<any, any>;
export declare const StyledBarProgress: StyletronComponent<any, any>;
export declare const StyledInfiniteBar: StyletronComponent<any, any>;
export declare const StyledLabel: StyletronComponent<any, any>;
